/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2011 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sh_scif.c 2150 2011-07-11 06:07:09Z mit-kimai $
 */

/*
 *   SH SCIF ʰSIOɥ饤
 *   
 *   ƥ¸֤ˡpdic/shǥ쥯ȥ֤Ƥ
 *   Τϡsh1/2ash3/4aǶͭ뤿
 */

#include <sil.h>
#include "target_syssvc.h"
#include "sh_scif.h"

/*
 * SH SCIFΥ쥸
 */

/*
 * ƥ쥸Υեå
 */
#define SCIF_SCSMR   0x0000U  /* H */
#define SCIF_SCBRR   0x0004U  /* B */
#define SCIF_SCSCR   0x0008U  /* H */
#define SCIF_SCFTDR  0x000cU  /* B */
#define SCIF_SCFSR   0x0010U  /* H */
#define SCIF_SCFRDR  0x0014U  /* B */
#define SCIF_SCFCR   0x0018U  /* H */
#define SCIF_SCFDR   0x001cU  /* H */
#define SCIF_SCSPTR  0x0024U  /* H */

/*
 * ƥ쥸
 */
#define SCSMR_CHR    0x0040U
#define SCSMR_PE     0x0020U
#define SCSMR_OE     0x0010U
#define SCSMR_STOP   0x0008U
#define SCSMR_CKS1   0x0002U
#define SCSMR_CKS0   0x0001U

#define SCSCR_TIE    0x0080U
#define SCSCR_RIE    0x0040U
#define SCSCR_TE     0x0020U
#define SCSCR_RE     0x0010U
#define SCSCR_CKE1   0x0002U
#define SCSCR_CKE0   0x0001U

#define SCFSR_ER     0x0080U
#define SCFSR_TEND   0x0040U
#define SCFSR_TDFE   0x0020U
#define SCFSR_BRK    0x0010U
#define SCFSR_FER    0x0008U
#define SCFSR_PER    0x0004U
#define SCFSR_RDF    0x0002U
#define SCFSR_DR     0x0001U

#define SCFCR_RTRG1  0x0080U
#define SCFCR_RTRG0  0x0040U
#define SCFCR_TTRG1  0x0020U
#define SCFCR_TTRG0  0x0010U
#define SCFCR_MCE    0x0008U
#define SCFCR_TFRST  0x0004U
#define SCFCR_RFRST  0x0002U
#define SCFCR_LOOP   0x0001U

#define SCSPTR_RTSIO  0x0080U
#define SCSPTR_RTSDT  0x0040U
#define SCSPTR_CTSIO  0x0020U
#define SCSPTR_CTSDT  0x0010U
#define SCSPTR_SPB2IO 0x0002U
#define SCSPTR_SPB2DT 0x0001U

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
    uint16_t *scsmr_h;   /* ꥢ⡼ɥ쥸 */
    uint8_t  *scbrr_b;   /* ӥåȥ졼ȥ쥸 */
    uint16_t *scscr_h;   /* ꥢ륳ȥ쥸 */
    uint8_t  *scftdr_b;  /* ȥ󥹥ߥåFIFOǡ쥸 */
    uint16_t *scfsr_h;   /* ꥢ륹ơ쥸 */
    uint8_t  *scfrdr_b;  /* 쥷FIFOǡ쥸 */
    uint16_t *scfcr_h;   /* FIFOȥ쥸 */
    uint16_t *scfdr_h;   /* 쥷FIFOǡ쥸 */
    uint16_t *scsptr_h;  /* ꥢݡȥ쥸 */
    uint8_t bps_setting; /* ܡ졼Ȥ */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
    const SIOPINIB  *p_siopinib;  /* ꥢI/OݡȽ֥å */
    intptr_t  exinf;              /* ĥ */
    bool_t    openflag;           /* ץѤߥե饰 */
    bool_t    sendflag;           /* ߥ֥͡ե饰 */
    bool_t    getready;           /* ʸ */
    bool_t    putready;           /* ʸǤ */
    bool_t    is_initialized;     /* ǥХѤߥե饰 */
};

/*
 *  ꥢI/OݡȽ֥å
 */
static const SIOPINIB siopinib_table[TNUM_SIOP] = {
    {
        (uint16_t *)(SH_SCIF0_BASE + SCIF_SCSMR),
        (uint8_t  *)(SH_SCIF0_BASE + SCIF_SCBRR),
        (uint16_t *)(SH_SCIF0_BASE + SCIF_SCSCR),
        (uint8_t  *)(SH_SCIF0_BASE + SCIF_SCFTDR),
        (uint16_t *)(SH_SCIF0_BASE + SCIF_SCFSR),
        (uint8_t  *)(SH_SCIF0_BASE + SCIF_SCFRDR),
        (uint16_t *)(SH_SCIF0_BASE + SCIF_SCFCR),
        (uint16_t *)(SH_SCIF0_BASE + SCIF_SCFDR),
        (uint16_t *)(SH_SCIF0_BASE + SCIF_SCSPTR),
        SCIF0_BPS_SETTING,
    },
#if TNUM_SIOP > 1
    {        
        (uint16_t *)(SH_SCIF1_BASE + SCIF_SCSMR),
        (uint8_t  *)(SH_SCIF1_BASE + SCIF_SCBRR),
        (uint16_t *)(SH_SCIF1_BASE + SCIF_SCSCR),
        (uint8_t  *)(SH_SCIF1_BASE + SCIF_SCFTDR),
        (uint16_t *)(SH_SCIF1_BASE + SCIF_SCFSR),
        (uint8_t  *)(SH_SCIF1_BASE + SCIF_SCFRDR),
        (uint16_t *)(SH_SCIF1_BASE + SCIF_SCFCR),
        (uint16_t *)(SH_SCIF1_BASE + SCIF_SCFDR),
        (uint16_t *)(SH_SCIF1_BASE + SCIF_SCSPTR),
        SCIF1_BPS_SETTING,
    },
#endif /* TNUM_SIOP > 1 */   
#if TNUM_SIOP > 2
    {
        (uint16_t *)(SH_SCIF2_BASE + SCIF_SCSMR),
        (uint8_t  *)(SH_SCIF2_BASE + SCIF_SCBRR),
        (uint16_t *)(SH_SCIF2_BASE + SCIF_SCSCR),
        (uint8_t  *)(SH_SCIF2_BASE + SCIF_SCFTDR),
        (uint16_t *)(SH_SCIF2_BASE + SCIF_SCFSR),
        (uint8_t  *)(SH_SCIF2_BASE + SCIF_SCFRDR),
        (uint16_t *)(SH_SCIF2_BASE + SCIF_SCFCR),
        (uint16_t *)(SH_SCIF2_BASE + SCIF_SCFDR),
        (uint16_t *)(SH_SCIF2_BASE + SCIF_SCSPTR),
        SCIF2_BPS_SETTING,
    }
#endif /* TNUM_SIOP > 2 */
};


/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
static SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)	 ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)	 (&(siopcb_table[INDEX_SIOP(siopid)]))
#define get_siopinib(siopid) (&(siopinib_table[INDEX_SIOP(siopid)]))

/* 
 *  ֥åؤΥݥ󥿤饷ꥢI/OݡIDФΥޥ 
 */ 
#define SIOPID(p_siopcb)    ((ID)((p_siopcb) - siopcb_table))

/*
 *  ʸ
 */
Inline bool_t
sh_scif_getready(SIOPCB *p_siopcb)
{
#ifndef TOPPERS_HEW_SIMULATOR
    return((sil_reh_mem(p_siopcb->p_siopinib->scfsr_h) & SCFSR_RDF) != 0);
#else /* TOPPERS_HEW_SIMULATOR */
	return true;
#endif /* TOPPERS_HEW_SIMULATOR */
}

/*
 *  ʸǤ뤫
 */
Inline bool_t
sh_scif_putready(SIOPCB *p_siopcb)
{
    return((sil_reh_mem(p_siopcb->p_siopinib->scfsr_h) & SCFSR_TDFE) != 0);
}

/*
 *  ʸμФ
 */
Inline char_t
sh_scif_getchar(SIOPCB *p_siopcb)
{
    uint8_t c;
    c = sil_reb_mem(p_siopcb->p_siopinib->scfrdr_b);
    sil_wrh_mem(p_siopcb->p_siopinib->scfsr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scfsr_h) & ~SCFSR_RDF));
    return(c);
}

/*
 *  ʸν
 */
Inline void
sh_scif_putchar(SIOPCB *p_siopcb, char_t c)
{
    sil_wrb_mem(p_siopcb->p_siopinib->scftdr_b, (uint8_t)c);
    sil_wrh_mem(p_siopcb->p_siopinib->scfsr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scfsr_h) & ~(SCFSR_TDFE)));
}

/*
 *  ߵ
 */
Inline void
sh_scif_enable_send(SIOPCB *p_siopcb)
{
    sil_wrh_mem(p_siopcb->p_siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scscr_h) | SCSCR_TIE));
}

/*
 *  ߶ػ
 */
Inline void
sh_scif_disable_send(SIOPCB *p_siopcb)
{
    sil_wrh_mem(p_siopcb->p_siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scscr_h) & ~SCSCR_TIE));
}


/*
 *  ߵ
 */
Inline void
sh_scif_enable_rcv(SIOPCB *p_siopcb)
{
    sil_wrh_mem(p_siopcb->p_siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scscr_h) | SCSCR_RIE));    
}

/*
 *  ߶ػ
 */
Inline void
sh_scif_disable_rcv(SIOPCB *p_siopcb)
{
    sil_wrh_mem(p_siopcb->p_siopinib->scscr_h,
                (sil_reh_mem(p_siopcb->p_siopinib->scscr_h) & ~SCSCR_RIE));
}

/*
 *  SIOɥ饤Фν
 */
void
sh_scif_initialize(void)
{
	SIOPCB	*p_siopcb;
	uint_t	i;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
        p_siopcb->p_siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }
}


/*
 * ϡɥν
 */
static void
sh_scif_init_siopinib(const SIOPINIB *p_siopinib)
{
    /* UART */
	sil_wrh_mem(p_siopinib->scscr_h, 0x00U);    

    /* FIFO򥯥ꥢ */   
	sil_wrh_mem(p_siopinib->scfcr_h, (SCFCR_TFRST|SCFCR_RFRST));

    /*  8ǡ,1ȥåץӥå,no parity */
    sil_wrh_mem(p_siopinib->scsmr_h, 0x0000U);

    /*  ^RTS2 ˽ */
    sil_wrh_mem(p_siopinib->scsptr_h, SCSPTR_RTSIO);
   
	/* ܡ졼Ȥ */
    sil_wrb_mem(p_siopinib->scbrr_b, p_siopinib->bps_setting);

    /*
     * 1ӥåʬԤɬפ
     */
    sil_dly_nse(SIO_INIT_DLY);
    
    /* ơΥꥢ */
    sil_wrh_mem(p_siopinib->scfsr_h,
                sil_reh_mem(p_siopinib->scfsr_h) & ~(SCFSR_TEND|SCFSR_TDFE));
    
    /* ȥꥬ R-FIFO=1,T-FIFO=1 */
	sil_wrh_mem(p_siopinib->scfcr_h, (SCFCR_TTRG1|SCFCR_TTRG0));

    /* UART */
	sil_wrh_mem(p_siopinib->scscr_h, (SCSCR_TE|SCSCR_RE));
}


/*
 * ͥ뵯ưΥСʽѤν
 */
void
sh_scif_init(ID siopid)
{
    SIOPCB          *p_siopcb   = get_siopcb(siopid);
    const SIOPINIB  *p_siopinib = get_siopinib(siopid);
    /*  λǤϡp_siopcb->p_siopinibϽƤʤ  */
    
    /*  Žɻ  */
    p_siopcb->is_initialized = true;

	/*  ϡɥν  */
    sh_scif_init_siopinib(p_siopinib);
}

/*
 *  ݡnץѤߤʥݡID
 */
bool_t
sh_scif_openflag_id(ID siopid)
{
	return(get_siopcb(siopid)->openflag);
}

/*
 *  ݡnץѤߤ
 *  ʡ֥ꥢI/Oݡȴ֥åפƬϤ
 */
bool_t
sh_scif_openflag_cb(SIOPCB *p_siopcb)
{
	return(p_siopcb->openflag);
}

/* 
 *  ݡIDμ 
 */ 
ID 
sh_scif_get_siopid(SIOPCB *p_siopcb) 
{ 
    return(SIOPID(p_siopcb)); 
} 

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sh_scif_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB          *p_siopcb;
    const SIOPINIB  *p_siopinib;
      
    p_siopcb = get_siopcb(siopid);
    p_siopinib = p_siopcb->p_siopinib;

    /*
     * ϡɥν     
     * ˽ƤϡŤ˽ʤ
     */
    if (!(p_siopcb->is_initialized)) {
    	sh_scif_init_siopinib(p_siopinib);
    	p_siopcb->is_initialized = true;
    }

    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sh_scif_cls_por(SIOPCB *p_siopcb)
{
    /*
     * UART
     */
	sil_wrh_mem(p_siopcb->p_siopinib->scscr_h, 0x00);
    p_siopcb->openflag = false;
   	p_siopcb->is_initialized = false;
}


/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
void
sh_scif_pol_putc(char_t c, ID siopid)
{
    const SIOPINIB *p_siopinib;
    uint32_t scfsr;
    void *p_scfsr;
    SIL_PRE_LOC;
    
    p_siopinib = get_siopinib(siopid);
    p_scfsr = p_siopinib->scfsr_h;
    
	while(1) {
		/*
		 *  ꥨȥȤˤ뤿ᡢߥå֤ˤ롣
		 */
		SIL_LOC_INT();
		scfsr = sil_reh_mem(p_scfsr);
		
		if ((scfsr & SCFSR_TDFE) == 0) {
			/*
			 *  ߥåơߤդ롣
			 */
			SIL_UNL_INT();
		} else {
			sil_wrb_mem(p_siopinib->scftdr_b, (uint8_t)c);
			scfsr = sil_reh_mem(p_scfsr);
			sil_wrh_mem(p_scfsr, scfsr & ~SCFSR_TDFE);
			/*
			 *  ꥿󤹤ߥåե饰򸵤ξ֤᤹
			 */
			SIL_UNL_INT();
			return;
		}
	}
}


/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sh_scif_snd_chr(SIOPCB *p_siopcb, char_t c)
{
    if (sh_scif_putready(p_siopcb)){
        sh_scif_putchar(p_siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sh_scif_rcv_chr(SIOPCB *p_siopcb)
{
	if (sh_scif_getready(p_siopcb)) {
		return((int_t)sh_scif_getchar(p_siopcb));
	}
	return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sh_scif_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        sh_scif_enable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        sh_scif_enable_rcv(p_siopcb);
        break;
    }
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sh_scif_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        sh_scif_disable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        sh_scif_disable_rcv(p_siopcb);
        break;
    }
}

/*
 *  SIOγߥӥ롼
 */
void
sh_scif_tx_isr(ID siopid)
{
    SIOPCB	*p_siopcb = get_siopcb(siopid);
    
    if (sh_scif_putready(p_siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        sh_scif_irdy_snd(p_siopcb->exinf);
    }
}


/*
 *  SIOγߥӥ롼
 */
void
sh_scif_rx_isr(ID siopid)
{
    SIOPCB	*p_siopcb = get_siopcb(siopid);
    
    if (sh_scif_getready(p_siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        sh_scif_irdy_rcv(p_siopcb->exinf);
    }
}
